<?php
//add_filter( 'bsf_meta_boxes', 'bsf_review_metaboxes' );
/**
 * Define the metabox and field configurations.
 *
 * @param  array $meta_boxes
 * @return array
 */

add_action( 'init', 'bsf_initialize_bsf_meta_boxes', 9999 );
/**
 * Initialize the metabox class.
 */
function bsf_initialize_bsf_meta_boxes() {

	if ( ! class_exists( 'bsf_Meta_Box' ) )
		require_once 'init.php';
}
//Function to display the rich snippet output below the content
function display_rich_snippet($content) {
	global $post;
	$id = $post->ID;
	$type = get_post_meta($id, '_bsf_post_type', true);
	if($type == '1')
	{
		global $post;
	//	echo $post->ID;
		$review = $content;
		$review .= '<div><h3>Review Summary :</h3></div>';
		$review .= "<div xmlns:v='http://rdf.data-vocabulary.org/#' typeof='v:Review'><table style='width:100%;'>";
		$item = get_post_meta( $post->ID, '_bsf_item_name', true );
		$rating = get_post_meta( $post->ID, '_bsf_rating', true );
		$desc = get_post_meta( $post->ID, '_bsf_item_desc', true );
		$reviewer = get_post_meta( $post->ID, '_bsf_item_reviewer', true);
		$post_date = get_the_date('Y-m-d');
		if(trim($reviewer) != "")
			$review .= "<tr style='border:1px solid #ddd;'><td style='padding:5px;'>Reviewer : </td><td><span property='v:reviewer'>".$reviewer."</span></td></tr>";
		$review .= "<tr style='border:1px solid #ddd;'><td style='padding:5px;'>Review Date : </td><td><span property='v:dtreviewed' content='".$post_date."'>".$post_date."</span></td></tr>";
		if(trim($item) != "")
			$review .= "<tr style='border:1px solid #ddd;'><td style='padding:5px;'>Item Name : </td><td><span property='v:itemreviewed'>".$item."</span></td></tr>";
		if(trim($rating) != "")
			$review .= "<tr style='border:1px solid #ddd;'><td style='padding:5px;'>Author Rating:  </td><td><span property='v:rating'>".$rating."</span></td></tr>";
		if(trim($desc) != "")
			$review .= "<tr style='border:1px solid #ddd;'><td style='padding:5px;'>Item Description: </td><td><span property='v:summary'>".$desc."</span></td></tr>";
		$review .= "</table></div>";
		return $review;
	} 
	else if($type == '2')
	{
		global $post;
		$event = $content;
		$event .= '<div><h3>Event Summary :</h3></div>';
		$event .= '<div xmlns:v="http://rdf.data-vocabulary.org/#" typeof="v:Event"><table id="tbl-rich-snippet">';
		$event_title = get_post_meta( $post->ID, '_bsf_event_title', true );
		$event_org = get_post_meta( $post->ID, '_bsf_event_organization', true );
		$event_street = get_post_meta( $post->ID, '_bsf_event_street', true );	
		$event_local = get_post_meta( $post->ID, '_bsf_event_local', true );	
		$event_region = get_post_meta( $post->ID, '_bsf_event_region', true );	
		$event_desc = get_post_meta( $post->ID, '_bsf_event_desc', true );	
		$event_start_date = get_post_meta( $post->ID, '_bsf_event_start_date', true );	
		$event_end_date = get_post_meta( $post->ID, '_bsf_event_end_date', true );	
		$event_geo_latitude = get_post_meta( $post->ID, '_bsf_event_geo_latitude', true );	
		$event_geo_longitude = get_post_meta( $post->ID, '_bsf_event_geo_longitude', true );	
		$event_photo = get_post_meta( $post->ID, '_bsf_event_photo', true );	
		if(trim($event_photo) != "")
			$event .= '<tr class="tbl-bsf-tr"  align="center"><td colspan="2" class="tbl-bsf-td"> <img src="'.$event_photo.'" rel="v:photo"></td></tr>';
		if(trim($event_title) != "")
			$event .= '<tr class="tbl-bsf-tr"><td style="padding:5px; width:30%;">Event : </td><td><span property="v:summary">'.$event_title.'</span></td></tr>';
		if(trim($event_desc) != "")
			$event .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Event Description : </td><td class="tbl-bsf-td"><span property="v:description">'.$event_desc.'</span></td></tr>';
		if(trim($event_org) != "")
			$event .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Location : </td><td>
					<span rel="v:location">
						<span typeof="v:Organization">
							<span property="v:name">'.$event_org.'</span>,</td></tr>';
		if(trim($event_street) != "")
			$event .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"><span rel="v:address">
							<span typeof="v:Address">
								  <span property="v:street-address">'.$event_street.'</span>,</td></tr>';
		if(trim($event_local) != "")
			$event .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"> <span property="v:locality">'.$event_local.'</span>,</td></tr>';
		if(trim($event_region) != "")
			$event .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"> <span property="v:region">'.$event_region.'</span>
					</span>
				</span></td></tr>';
		if(trim($event_geo_latitude) != "")
			$event .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">GEO : </td><td><span rel="v:geo">
								<span typeof="v:Geo">
								  <span property="v:latitude" content="'.$event_geo_latitude.'">'.$event_geo_latitude.'</span> - ';
		if(trim($event_geo_longitude) != "")
			$event .= '<span property="v:longitude" content="'.$event_geo_longitude.'">'.$event_geo_longitude.'</span>
						</span>
					</span>
				</span>
			</span>		</td></tr>';
		if(trim($event_start_date) != "")
			$event .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Start Date : </td><td><span property="v:startDate" content="'.$event_start_date.'">'.$event_start_date.'</span></td></tr>';
		if(trim($event_end_date) != "")
			$event .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">End Date : </td><td><span property="v:endDate" content="'.$event_end_date.'">'.$event_end_date.'</span></td></tr>';
		$event .= '</table></div>';
		return $event;
	}
	else if($type == '4')
	{
		global $post;
		$organization = $content;
		$organization .= '<div><h3>Organization Brief :</h3></div>';
		$organization .= '<div xmlns:v="http://rdf.data-vocabulary.org/#" typeof="v:Organization"><table id="tbl-rich-snippet">';
		$org_name = get_post_meta( $post->ID,'_bsf_organization_name', true );
		$org_url = get_post_meta( $post->ID,'_bsf_organization_url', true );
		$org_tel = get_post_meta( $post->ID,'_bsf_organization_tel', true );
		$org_street = get_post_meta( $post->ID,'_bsf_organization_street', true );
		$org_local = get_post_meta( $post->ID,'_bsf_organization_local', true );
		$org_region = get_post_meta( $post->ID,'_bsf_organization_region', true );
		$org_zip = get_post_meta( $post->ID,'_bsf_organization_zip', true );
		$org_country = get_post_meta( $post->ID,'_bsf_organization_country', true );
		$org_latitude = get_post_meta( $post->ID,'_bsf_organization_latitude', true );
		$org_longitude = get_post_meta( $post->ID,'_bsf_organization_longitude', true );
		if(trim($org_name) != "")
			$organization .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Organization Name : </td><td><span property="v:name">'.$org_name.'</span></td></tr>';
		if(trim($org_url) != "")
			$organization .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Website : </td><td><a href="'.$org_url.'" rel="v:url">'.$org_url.'</a></td></tr>';
		if(trim($org_tel) != "")
			$organization .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Telephone No. : </td><td><span property="v:tel">'.$org_tel.'</span></td></tr>';
		if(trim($org_street) != "")
			$organization .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Address : </td><td>
			<span rel="v:address">
				<span typeof="v:Address">
					<span property="v:street-address">'.$org_street.'</span></td></tr>';
		if(trim($org_local) != "")
			$organization .= '<tr class="tbl-bsf-tr tbl-addrs-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"><span property="v:locality">'.$org_local.'</span></td></tr>';
		if(trim($org_region) != "")
			$organization .= '<tr class="tbl-bsf-tr tbl-addrs-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td tbl-addrs-tr"><span property="v:region">'.$org_region.'</span></td></tr>';
		if(trim($org_zip) != "")
			$organization .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"><span property="v:postal-code">'.$org_zip.'</span></td></tr>';
		if(trim($org_country) != "")
			$organization .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"><span property="v:country-name">'.$org_country.'</span>
					</span>
				</span></td></tr>';
		if(trim($org_latitude) != "")
			$organization .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">GEO Location : </td><td>
			<span rel="v:geo">
				<span typeof="v:Geo">
						 <span property="v:latitude" content="'.$org_latitude.'">'.$org_latitude.'</span> - ';
		if(trim($org_longitude) != "")
			$organization .= '<span property="v:longitude" content="'.$org_longitude.'">'.$org_longitude.'</span>
				</span>
			</span></td></tr>';
		$organization .= '</table></div>';
		return $organization;
	}
	else if($type == '5')
	{
		global $post;
		$people = $content;
		$people .= '<div><h3>Short Bio:</h3></div>';
		$people .= '<div xmlns:v="http://rdf.data-vocabulary.org/#" typeof="v:Person"><table id="tbl-rich-snippet">';
		$people_fn = get_post_meta( $post->ID, '_bsf_people_fn', true );
		$people_nickname = get_post_meta( $post->ID, '_bsf_people_nickname', true );
		$people_photo = get_post_meta( $post->ID, '_bsf_people_photo', true );
		$people_job_title = get_post_meta( $post->ID, '_bsf_people_job_title', true );
		$people_website = get_post_meta( $post->ID, '_bsf_people_website', true );
		$people_company = get_post_meta( $post->ID, '_bsf_people_company', true );
		$people_local = get_post_meta( $post->ID, '_bsf_people_local', true );
		$people_region = get_post_meta( $post->ID, '_bsf_people_region', true );
		if(trim($people_photo) != "")
			$people .= '<tr class="tbl-bsf-tr"><td rowspan="6" class="tbl-bsf-td tbl-img"><img width="160" height="160" src="'.$people_photo.'" rel="v:photo" /></td></tr>';	
		if(trim($people_fn) != "")
			$people .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td"> <span property="v:name">'.$people_fn.'</span>';
		if(trim($people_nickname) != "")
			$people .= ' (<span property="v:nickname">'.$people_nickname.'</span>)</td></tr>';	
		if(trim($people_website) != "")
			$people .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"> <a href="'.$people_website.'" rel="v:url">'.$people_website.'</a></td></tr>';	
		if(trim($people_job_title) != "")
			$people .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"><span property="v:title">'.$people_job_title.'</span></td></tr>';	
		if(trim($people_company) != "")
			$people .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"><span property="v:affiliation">'.$people_company.'</span></td></tr>';	
		if(trim($people_local) != "")
			$people .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td"></td><td class="tbl-bsf-td"> 
			<span rel="v:address">
				<span typeof="v:Address">
					<span property="v:locality">'.$people_local.'</span>, ';	
		if(trim($people_region) != "")
			$people .= '<span property="v:region">'.$people_region.'</span>
				</span>
			</span></td></tr>';	
		$people .= '</table></div>';
		return $people;
	}
	else if($type == '6')
	{
		global $post;
		$product = $content;
		$product .= '<div><h3>Product Summary :</h3></div>';
		$product .= '<div xmlns:v="http://rdf.data-vocabulary.org/#" typeof="v:Product"><table id="tbl-rich-snippet">';
		$product_rating = get_post_meta( $post->ID, '_bsf_product_rating', true);
		$product_brand = get_post_meta( $post->ID, '_bsf_product_brand', true);
		$product_name = get_post_meta( $post->ID, '_bsf_product_name', true);
		$product_image = get_post_meta($post->ID, '_bsf_product_image', true);
		$product_cat = get_post_meta($post->ID, '_bsf_product_cat', true);
		$product_price = get_post_meta($post->ID, '_bsf_product_price', true);
		$product_status = get_post_meta($post->ID, '_bsf_product_status', true);
		if(trim($product_status) == "out_of_stock")
			$availability = "Out of Stock";
		else if(trim($product_status) == "in_stock")
			$availability = "Available in Stock";
		else if(trim($product_status) == "instore_only")
			$availability = "Available in Store Only";
		else if(trim($product_status) == "preorder")
			$availability = "Pre-Order Only";
			
		if(trim($product_rating) != "")
			$product .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Rating : </td><td class="tbl-bsf-td"><span property="v:rating">'.$product_rating.'</span></td></tr>';
		if(trim($product_brand) != "")
			$product .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Brand Name : </td><td class="tbl-bsf-td"><span property="v:brand">'.$product_brand.'</span></td></tr>';
		if(trim($product_name) != "")
			$product .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Product Name : </td><td class="tbl-bsf-td"><span property="v:name">'.$product_name.'</span></td></tr>';
		if(trim($product_cat) != "")
			$product .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Category : </td><td class="tbl-bsf-td"><span property="v:category">'.$product_cat.'</span></td></tr>';
		if(trim($product_image) != "")
			$product .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Price : </td><td class="tbl-bsf-td"><span typeof="currency" content="USD"><span property="v:price">'.$product_price.'</span></span></td></tr>';
		if(trim($product_status) != "")
			$product .= '<tr class="tbl-bsf-tr"><td class="tbl-bsf-td">Availability : </td><td class="tbl-bsf-td"><span property="v:availability" content="'.$product_status.'">'.$availability.'</span></td></tr>';		
		if(trim($product_image) != "")
			$product .= '<tr class="tbl-bsf-tr"><td colspan="2" class="tbl-bsf-td"><img src="'.$product_image.'" itemprop="image" /></td></tr>';
		$product .= '</table></div>';
		return $product;
	}
	else if($type == '7')
	{
		global $post;
		$recipe = $content;
		$recipe .= '<div><h3>Recipe in Short :</h3></div>';
		$recipe .= '<div xmlns:v="http://rdf.data-vocabulary.org/#" typeof="v:Recipe"><table id="tbl-rich-snippet">';
		$recipes_name = get_post_meta( $post->ID, '_bsf_recipes_name', true );
		$recipes_preptime = get_post_meta( $post->ID, '_bsf_recipes_preptime', true );
		$recipes_cooktime = get_post_meta( $post->ID, '_bsf_recipes_cooktime', true );
		$recipes_totaltime = get_post_meta( $post->ID, '_bsf_recipes_totaltime', true );
		$recipes_photo = get_post_meta( $post->ID, '_bsf_recipes_photo', true );
		$recipes_desc = get_post_meta( $post->ID, '_bsf_recipes_desc', true );
		$recipes_ingredient = get_post_meta( $post->ID, '_bsf_recipes_ingredient', true );
		if(trim($recipes_photo) != "")
			$recipe .= '<tr class="tbl-bsf-tr"><td rowspan="8" style="padding:5px; width:180px;"><img width="160" height="160" src="'.$recipes_photo.'" rel="v:photo" /></td></tr>';
		if(trim($recipes_name) != "")
			$recipe .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Recipe : <h1 property="v:name">'.$recipes_name.'</h1></td></tr>';
		$recipe .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Published on : <span property="v:published" content="'.get_the_date('Y-m-d').'">'.get_the_date('Y-m-d').'</span></td></tr>';
		if(trim($recipes_preptime) != "")
			$recipe .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Prep. Time : <span property="v:prepTime" content="'.$recipes_preptime.'">'.$recipes_preptime.'</span></td></tr>';
		if(trim($recipes_cooktime) != "")
			$recipe .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Cook Time : <span property="v:cookTime" content="'.$recipes_cooktime.'">'.$recipes_cooktime.'</span></td></tr>';
		if(trim($recipes_totaltime) != "")
			$recipe .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Total Time : '.$recipes_totaltime.'</td></tr>';
		if(trim($recipes_ingredient) != "")
			$recipe .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Ingredients Used : '.$recipes_ingredient.'</td></tr>';												
		if(trim($recipes_desc) != "")
			$recipe .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Summary : <span property="v:summary">'.$recipes_desc.'</span></td></tr>';
		$recipe .= '</table></div>';
		return $recipe;
	}
	else if($type == '8')
	{
		global $post;
		$software = $content;
		$software .= '<div><h3>Software Overview :</h3></div>';
		$software .= '<div itemscope itemtype="http://schema.org/SoftwareApplication"><table id="tbl-rich-snippet">';
		$software_rating = get_post_meta( $post->ID, '_bsf_software_rating', true);
		$software_name = get_post_meta( $post->ID, '_bsf_software_name', true );
		$software_desc = get_post_meta( $post->ID, '_bsf_software_desc', true );
		$software_landing = get_post_meta( $post->ID, '_bsf_software_landing', true );
		$software_image = get_post_meta( $post->ID, '_bsf_software_image', true );
		$software_price = get_post_meta( $post->ID, '_bsf_software_price', true );
		$software_os = get_post_meta( $post->ID, '_bsf_software_os', true );
		if(trim($software_image) != "")
			$software .= '<tr class="tbl-bsf-tr"><td rowspan="7" style="padding:5px; width:180px;"><img width="180" height="180" src="'.$software_image.'" itemprop="image" /></td></tr>';	
		if(trim($software_rating) != "")
			$software .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Rating : <div itemprop="aggregateRating" itemscope itemtype="http://schema.org/AggregateRating"><span itemprop="ratingValue">'.$software_rating.'</span></div></td></tr>';
		if(trim($software_name) != "")
			$software .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Name : <span itemprop="name">'.$software_name.'</span></td></tr>';
		if(trim($software_os) != "")
			$software .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Operating System : <span itemprop="operatingSystems">'.$software_os.'</span></td></tr>';		
		if(trim($software_price) != "")
			$software .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Price : <div itemprop="offers" itemscope itemtype="http://schema.org/Offer"><span itemprop="price">'.$software_price.'</span></div></td></tr>';			
		if(trim($software_desc) != "")
			$software .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Description : <span itemprop="description">'.$software_desc.'</span></td></tr>';
		if(trim($software_landing) != "")
			$software .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td">Landing Page : 
<a itemprop="url" href="'.$software_landing.'">'.$software_landing.'</a></td></tr>';
		$software .= '</table></div>';
		return $software;
	}
	else if($type == '9')
	{
		global $post;
		$video = $content;
		$video .= '<div><h3>Video Summary :</h3></div>';
		$video .= '<div itemprop="video" itemscope itemtype="http://schema.org/VideoObject"><table id="tbl-rich-snippet">';
		$video_title = get_post_meta( $post->ID, '_bsf_video_title', true );
		$video_desc = get_post_meta( $post->ID, '_bsf_video_desc', true );
		$video_thumb = get_post_meta( $post->ID, '_bsf_video_thumb', true );
		$video_url = get_post_meta( $post->ID, '_bsf_video_url', true );
		$video_duration = get_post_meta( $post->ID, '_bsf_video_duration', true );
		$video_date = get_post_meta( $post->ID, '_bsf_video_date', true );
		if(trim($video_url) != "")
			$video .= '<tr class="tbl-bsf-tr"><td rowspan="3" style="padding:5px; width:180px;"><a itemprop="url" href="'.$video_url.'"><img width="220" height="160" src="'.$video_thumb.'"></a></td></tr>';	
		if(trim($video_title) != "")
			$video .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td"><h2 itemprop="name">'.$video_title.'</h2></td></tr>';
		if(trim($video_desc) != "")
			$video .= '<tr class="tbl-bsf-tr"><td></td><td class="tbl-bsf-td"><p itemprop="description">'.$video_desc.'</p></td></tr>';		
		if(trim($video_thumb) != "")
			$video .= '<meta itemprop="thumbnail" content="'.$video_thumb.'">';		
		if(trim($video_duration) != "")
			$video .= '<meta itemprop="duration" content="'.$video_duration.'">';		
		if(trim($video_date) != "")
			$video .= '<meta itemprop="date" content="'.$video_date.'">';		
		$video .= '</table></div>';
		return $video;
	} else {
		return $content;
	}
}
//Filter the content and return with rich snippet output
add_filter('the_content','display_rich_snippet');
require_once('meta-boxes.php');